/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB� Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB� Code Configurator - v2.0
        Device            :  PIC18F45K22
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.32
        MPLAB             :  MPLAB X 2.10
*/

/*
Copyright (c) 2013 - 2014 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
*/

#include <stdio.h>
#include <string.h>

#include "mcc_generated_files/mcc.h"
#include "app.h"
#include "APP001_LCD.h"

/*
                         Main application
 */
void main(void)
{
    int adcResult;

    // Initialize the device
    SYSTEM_Initialize();

    // If using interrupts in PIC18 High/Low Priority Mode you need to enable the Global High and Low Interrupts
    // If using interrupts in PIC Mid-Range Compatibility Mode you need to enable the Global and Peripheral Interrupts
    // Use the following macros to:

    // Enable high priority global interrupts
    //INTERRUPT_GlobalInterruptHighEnable();

    // Enable low priority global interrupts.
    //INTERRUPT_GlobalInterruptLowEnable();

    // Disable high priority global interrupts
    //INTERRUPT_GlobalInterruptHighDisable();

    // Disable low priority global interrupts.
    //INTERRUPT_GlobalInterruptLowDisable();

    // Enable the Global Interrupts
    //INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    __delay_ms(500);  //確保系統USB轉RS232穩定
    // printf("\r\nMCC: It's Easy!\r\nPIC18 Lab 2-1\r\n");  // 使用 printf( ) 來列印字串
    putrs1USART("\r\nMCC: It's Easy!\r\nPIC18 Lab 2-1\r\n");  // 呼叫 app.c 的 UART1 函數來送出字串

    /*Start the timer with Period 1s */
    TMR1_StartTimer( );

    LCD_L_Delay();              // 10mS
    OpenLCD();

    while (1)
    {
        // Add your application code

        if(TMR1IF)
        {
            LED_D8_Toggle();
            TMR1_Reload();
            TMR1IF = 0;

            adcResult = ADC_GetConversion(POT_CHANNEL);    // ADC 轉換，再讀取 ADC 的 16 進制值

            // 在 LCD 第一行顯示 "ADC Hex = 0x03FF"
            LCD_Set_Cursor(0,0);
            putrsLCD((const far char*)"ADC Hex = 0x   ");
            LCD_Set_Cursor(0,12);
            puthexLCD(adcResult>>8);
            puthexLCD(adcResult);

            ConvertADCVoltage(adcResult);       //呼叫 app.c 裡的 10 進制轉換函數
            // 將電壓值送到終端機顯示
            printf(" Potentiometer Analog Voltage is %d.%d%d%d V \r\n",A1000_mV,A100_mV,A10_mV,mV);

            // 在 LCD 第二行顯示 "ADC Volt= 4.910V"
            LCD_Set_Cursor(1,0);
            putrsLCD((const far char*)"ADC Volt=      V");
            LCD_Set_Cursor(1,10);
            // TODO : 在 LCD 的第二行顯示出類比的電壓值
            // 提示 : 使用 putcLCD( ) 函數來顯示一個字元，
            //        目前經十進制轉換後的值為 BCD 型態，需再轉成 ASCII 後才可以在 LCD 上顯示
            putcLCD(A1000_mV + '0');        // 印出個位數的電壓值
            putcLCD('.');                   // 印出小數點
            putcLCD(A100_mV + '0');         // 印出十分位的電壓值
            putcLCD(A10_mV + '0');          // 印出百分位的電壓值
            putcLCD(mV + '0');              // 印出千分位的電壓值 (mV)

        }
    }
}

/**
 End of File
*/
