/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs 

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs  - 1.45
        Device            :  PIC18F45K22
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.40
*/

/*
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
*/

#include "mcc_generated_files/mcc.h"
#include <stdio.h>
#include "APP001_LCD.h"

#define EEPROM_ADDRESS      0x0000
#define EEPROM_WRITE_CMD    0x02
#define EEPROM_READ_CMD     0x03
#define EEPROM_EN_CMD       0x06
#define EEPROM_DI_CMD       0x04
#define EEPROM_PAGE_SIZE    16          // 24LC160C Page Size

unsigned char EE_Read_Buffer[30] = {0x00};
unsigned char EE_CMD_Buffer[3] = {0x00};
unsigned char EE_Write_Buffer [ ] = { 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4a, 0x4b, 0x4c, 0x4d, 0x4e, 0x4f,
                                      0x50, 0x51, 0x52, 0x53, 0x00 };
unsigned char Read_Dummy = 0x00;
unsigned char Dummy_Data = 0x00; 

 void main(void)
{
 
    SYSTEM_Initialize();

    LCD_L_Delay();                          // 10mS 等 LCD 模組穩定
    OpenLCD();
    LCD_Set_Cursor(0,0);
    putrsLCD((const far char*)"Lab5-1 Page Mode");

    // 允許 EEPROM 被寫入
    EEPROM_CHIP_SELECT_SetLow();
    SPI1_Exchange8bit(EEPROM_EN_CMD);        // EEPROM 寫入致能命令 (0x06)
    EEPROM_CHIP_SELECT_SetHigh();
    __delay_ms(1);

    // 設定寫入命令及寫入的起始位址
    EE_CMD_Buffer[0] = EEPROM_WRITE_CMD;    // 設定寫入命令及起始位址 0x0000
    EE_CMD_Buffer[1] = 0x00;                // MSB Address
    EE_CMD_Buffer[2] = 0x00;                // LSB Address

    // 先寫入命令及起始位址後再連續寫入 16 Bytes 的資料
    EEPROM_CHIP_SELECT_SetLow();
    SPI1_Exchange8bitBuffer(EE_CMD_Buffer,3,NULL);              // 從 SPI1 送出 EEPROM_WRITE_CMD & 16-bit 的起始位址
    SPI1_Exchange8bitBuffer(EE_Write_Buffer, 16, NULL);         // Page Write to EEPROM, 從陣列 EE_Write_Buffer[ ]，共送出 16 Bytes
    EEPROM_CHIP_SELECT_SetHigh();

    // delay 10mS 做寫入的延遲
    __delay_ms(10);
    

    // 設定讀取命令及起始位址
    EE_CMD_Buffer[0] = EEPROM_READ_CMD;
    EE_CMD_Buffer[1] = 0x00;
    EE_CMD_Buffer[2] = 0x00;

    // 送出讀取命令及起始位址，再連續讀取 16 Bytes 資料
    EEPROM_CHIP_SELECT_SetLow();
    SPI1_Exchange8bitBuffer(EE_CMD_Buffer,3,NULL);            // 從 SPI1 送出 EEPROM_READ_CMD & 16-bit 的起始位址
    SPI1_Exchange8bitBuffer(NULL, 16, EE_Read_Buffer);        // Page Read from EEPROM data, 共 16 Bytes 到陣列 EE_Read_Buffer[ ]
    EEPROM_CHIP_SELECT_SetHigh();

    // 顯示前六個 Bytes 的讀取值
    LCD_Set_Cursor(1,0);
    puthexLCD(EE_Read_Buffer[0]);
    putcLCD(' ');
    puthexLCD(EE_Read_Buffer[1]);
    putcLCD(' ');
    puthexLCD(EE_Read_Buffer[2]);
    putcLCD(' ');
    puthexLCD(EE_Read_Buffer[3]);
    putcLCD(' ');
    puthexLCD(EE_Read_Buffer[4]);

    while (1); 
    
}




/**
 End of File
*/
