/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB(c) Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 4.26
        Device            :  PIC18F45K22
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.40

    Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

    Microchip licenses to you the right to use, modify, copy and distribute
    Software only when embedded on a Microchip microcontroller or digital signal
    controller that is integrated into your product or third party product
    (pursuant to the sublicense terms in the accompanying license agreement).

    You should refer to the license agreement accompanying this Software for
    additional information regarding your rights and obligations.

    SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
    EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
    MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
    IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
    CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
    OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
    INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
    CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
    SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
    (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.

*/


#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set POT_CHANNEL aliases
#define POT_CHANNEL_TRIS               TRISAbits.TRISA0
#define POT_CHANNEL_LAT                LATAbits.LATA0
#define POT_CHANNEL_PORT               PORTAbits.RA0
#define POT_CHANNEL_ANS                ANSELAbits.ANSA0
#define POT_CHANNEL_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define POT_CHANNEL_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define POT_CHANNEL_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define POT_CHANNEL_GetValue()           PORTAbits.RA0
#define POT_CHANNEL_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define POT_CHANNEL_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define POT_CHANNEL_SetAnalogMode()  do { ANSELAbits.ANSA0 = 1; } while(0)
#define POT_CHANNEL_SetDigitalMode() do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set LCD_E aliases
#define LCD_E_TRIS               TRISAbits.TRISA2
#define LCD_E_LAT                LATAbits.LATA2
#define LCD_E_PORT               PORTAbits.RA2
#define LCD_E_ANS                ANSELAbits.ANSA2
#define LCD_E_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define LCD_E_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define LCD_E_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define LCD_E_GetValue()           PORTAbits.RA2
#define LCD_E_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define LCD_E_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define LCD_E_SetAnalogMode()  do { ANSELAbits.ANSA2 = 1; } while(0)
#define LCD_E_SetDigitalMode() do { ANSELAbits.ANSA2 = 0; } while(0)

// get/set EEPROM_CHIP_SELECT aliases
#define EEPROM_CHIP_SELECT_TRIS               TRISAbits.TRISA5
#define EEPROM_CHIP_SELECT_LAT                LATAbits.LATA5
#define EEPROM_CHIP_SELECT_PORT               PORTAbits.RA5
#define EEPROM_CHIP_SELECT_ANS                ANSELAbits.ANSA5
#define EEPROM_CHIP_SELECT_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define EEPROM_CHIP_SELECT_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define EEPROM_CHIP_SELECT_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define EEPROM_CHIP_SELECT_GetValue()           PORTAbits.RA5
#define EEPROM_CHIP_SELECT_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define EEPROM_CHIP_SELECT_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define EEPROM_CHIP_SELECT_SetAnalogMode()  do { ANSELAbits.ANSA5 = 1; } while(0)
#define EEPROM_CHIP_SELECT_SetDigitalMode() do { ANSELAbits.ANSA5 = 0; } while(0)

// get/set RC2 procedures
#define RC2_SetHigh()    do { LATCbits.LATC2 = 1; } while(0)
#define RC2_SetLow()   do { LATCbits.LATC2 = 0; } while(0)
#define RC2_Toggle()   do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define RC2_GetValue()         PORTCbits.RC2
#define RC2_SetDigitalInput()   do { TRISCbits.TRISC2 = 1; } while(0)
#define RC2_SetDigitalOutput()  do { TRISCbits.TRISC2 = 0; } while(0)
#define RC2_SetAnalogMode() do { ANSELCbits.ANSC2 = 1; } while(0)
#define RC2_SetDigitalMode()do { ANSELCbits.ANSC2 = 0; } while(0)

// get/set RC3 procedures
#define RC3_SetHigh()    do { LATCbits.LATC3 = 1; } while(0)
#define RC3_SetLow()   do { LATCbits.LATC3 = 0; } while(0)
#define RC3_Toggle()   do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define RC3_GetValue()         PORTCbits.RC3
#define RC3_SetDigitalInput()   do { TRISCbits.TRISC3 = 1; } while(0)
#define RC3_SetDigitalOutput()  do { TRISCbits.TRISC3 = 0; } while(0)
#define RC3_SetAnalogMode() do { ANSELCbits.ANSC3 = 1; } while(0)
#define RC3_SetDigitalMode()do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set RC4 procedures
#define RC4_SetHigh()    do { LATCbits.LATC4 = 1; } while(0)
#define RC4_SetLow()   do { LATCbits.LATC4 = 0; } while(0)
#define RC4_Toggle()   do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define RC4_GetValue()         PORTCbits.RC4
#define RC4_SetDigitalInput()   do { TRISCbits.TRISC4 = 1; } while(0)
#define RC4_SetDigitalOutput()  do { TRISCbits.TRISC4 = 0; } while(0)
#define RC4_SetAnalogMode() do { ANSELCbits.ANSC4 = 1; } while(0)
#define RC4_SetDigitalMode()do { ANSELCbits.ANSC4 = 0; } while(0)

// get/set RC5 procedures
#define RC5_SetHigh()    do { LATCbits.LATC5 = 1; } while(0)
#define RC5_SetLow()   do { LATCbits.LATC5 = 0; } while(0)
#define RC5_Toggle()   do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define RC5_GetValue()         PORTCbits.RC5
#define RC5_SetDigitalInput()   do { TRISCbits.TRISC5 = 1; } while(0)
#define RC5_SetDigitalOutput()  do { TRISCbits.TRISC5 = 0; } while(0)
#define RC5_SetAnalogMode() do { ANSELCbits.ANSC5 = 1; } while(0)
#define RC5_SetDigitalMode()do { ANSELCbits.ANSC5 = 0; } while(0)

// get/set LCD_DATA0 aliases
#define LCD_DATA0_TRIS               TRISDbits.TRISD0
#define LCD_DATA0_LAT                LATDbits.LATD0
#define LCD_DATA0_PORT               PORTDbits.RD0
#define LCD_DATA0_ANS                ANSELDbits.ANSD0
#define LCD_DATA0_SetHigh()            do { LATDbits.LATD0 = 1; } while(0)
#define LCD_DATA0_SetLow()             do { LATDbits.LATD0 = 0; } while(0)
#define LCD_DATA0_Toggle()             do { LATDbits.LATD0 = ~LATDbits.LATD0; } while(0)
#define LCD_DATA0_GetValue()           PORTDbits.RD0
#define LCD_DATA0_SetDigitalInput()    do { TRISDbits.TRISD0 = 1; } while(0)
#define LCD_DATA0_SetDigitalOutput()   do { TRISDbits.TRISD0 = 0; } while(0)
#define LCD_DATA0_SetAnalogMode()  do { ANSELDbits.ANSD0 = 1; } while(0)
#define LCD_DATA0_SetDigitalMode() do { ANSELDbits.ANSD0 = 0; } while(0)

// get/set LCD_DATA1 aliases
#define LCD_DATA1_TRIS               TRISDbits.TRISD1
#define LCD_DATA1_LAT                LATDbits.LATD1
#define LCD_DATA1_PORT               PORTDbits.RD1
#define LCD_DATA1_ANS                ANSELDbits.ANSD1
#define LCD_DATA1_SetHigh()            do { LATDbits.LATD1 = 1; } while(0)
#define LCD_DATA1_SetLow()             do { LATDbits.LATD1 = 0; } while(0)
#define LCD_DATA1_Toggle()             do { LATDbits.LATD1 = ~LATDbits.LATD1; } while(0)
#define LCD_DATA1_GetValue()           PORTDbits.RD1
#define LCD_DATA1_SetDigitalInput()    do { TRISDbits.TRISD1 = 1; } while(0)
#define LCD_DATA1_SetDigitalOutput()   do { TRISDbits.TRISD1 = 0; } while(0)
#define LCD_DATA1_SetAnalogMode()  do { ANSELDbits.ANSD1 = 1; } while(0)
#define LCD_DATA1_SetDigitalMode() do { ANSELDbits.ANSD1 = 0; } while(0)

// get/set LCD_DATA2 aliases
#define LCD_DATA2_TRIS               TRISDbits.TRISD2
#define LCD_DATA2_LAT                LATDbits.LATD2
#define LCD_DATA2_PORT               PORTDbits.RD2
#define LCD_DATA2_ANS                ANSELDbits.ANSD2
#define LCD_DATA2_SetHigh()            do { LATDbits.LATD2 = 1; } while(0)
#define LCD_DATA2_SetLow()             do { LATDbits.LATD2 = 0; } while(0)
#define LCD_DATA2_Toggle()             do { LATDbits.LATD2 = ~LATDbits.LATD2; } while(0)
#define LCD_DATA2_GetValue()           PORTDbits.RD2
#define LCD_DATA2_SetDigitalInput()    do { TRISDbits.TRISD2 = 1; } while(0)
#define LCD_DATA2_SetDigitalOutput()   do { TRISDbits.TRISD2 = 0; } while(0)
#define LCD_DATA2_SetAnalogMode()  do { ANSELDbits.ANSD2 = 1; } while(0)
#define LCD_DATA2_SetDigitalMode() do { ANSELDbits.ANSD2 = 0; } while(0)

// get/set LCD_DATA3 aliases
#define LCD_DATA3_TRIS               TRISDbits.TRISD3
#define LCD_DATA3_LAT                LATDbits.LATD3
#define LCD_DATA3_PORT               PORTDbits.RD3
#define LCD_DATA3_ANS                ANSELDbits.ANSD3
#define LCD_DATA3_SetHigh()            do { LATDbits.LATD3 = 1; } while(0)
#define LCD_DATA3_SetLow()             do { LATDbits.LATD3 = 0; } while(0)
#define LCD_DATA3_Toggle()             do { LATDbits.LATD3 = ~LATDbits.LATD3; } while(0)
#define LCD_DATA3_GetValue()           PORTDbits.RD3
#define LCD_DATA3_SetDigitalInput()    do { TRISDbits.TRISD3 = 1; } while(0)
#define LCD_DATA3_SetDigitalOutput()   do { TRISDbits.TRISD3 = 0; } while(0)
#define LCD_DATA3_SetAnalogMode()  do { ANSELDbits.ANSD3 = 1; } while(0)
#define LCD_DATA3_SetDigitalMode() do { ANSELDbits.ANSD3 = 0; } while(0)

// get/set LCD_RS aliases
#define LCD_RS_TRIS               TRISDbits.TRISD4
#define LCD_RS_LAT                LATDbits.LATD4
#define LCD_RS_PORT               PORTDbits.RD4
#define LCD_RS_ANS                ANSELDbits.ANSD4
#define LCD_RS_SetHigh()            do { LATDbits.LATD4 = 1; } while(0)
#define LCD_RS_SetLow()             do { LATDbits.LATD4 = 0; } while(0)
#define LCD_RS_Toggle()             do { LATDbits.LATD4 = ~LATDbits.LATD4; } while(0)
#define LCD_RS_GetValue()           PORTDbits.RD4
#define LCD_RS_SetDigitalInput()    do { TRISDbits.TRISD4 = 1; } while(0)
#define LCD_RS_SetDigitalOutput()   do { TRISDbits.TRISD4 = 0; } while(0)
#define LCD_RS_SetAnalogMode()  do { ANSELDbits.ANSD4 = 1; } while(0)
#define LCD_RS_SetDigitalMode() do { ANSELDbits.ANSD4 = 0; } while(0)

// get/set LCD_RW aliases
#define LCD_RW_TRIS               TRISDbits.TRISD5
#define LCD_RW_LAT                LATDbits.LATD5
#define LCD_RW_PORT               PORTDbits.RD5
#define LCD_RW_ANS                ANSELDbits.ANSD5
#define LCD_RW_SetHigh()            do { LATDbits.LATD5 = 1; } while(0)
#define LCD_RW_SetLow()             do { LATDbits.LATD5 = 0; } while(0)
#define LCD_RW_Toggle()             do { LATDbits.LATD5 = ~LATDbits.LATD5; } while(0)
#define LCD_RW_GetValue()           PORTDbits.RD5
#define LCD_RW_SetDigitalInput()    do { TRISDbits.TRISD5 = 1; } while(0)
#define LCD_RW_SetDigitalOutput()   do { TRISDbits.TRISD5 = 0; } while(0)
#define LCD_RW_SetAnalogMode()  do { ANSELDbits.ANSD5 = 1; } while(0)
#define LCD_RW_SetDigitalMode() do { ANSELDbits.ANSD5 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/