/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs 

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs  - 1.45
        Device            :  PIC18F45K22
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.40
*/

/*
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
*/

#include "mcc_generated_files/mcc.h"
#include <stdio.h>
#include "APP001_LCD.h"

#define EEPROM_ADDRESS      0x0000
#define EEPROM_WRITE_CMD    0x02
#define EEPROM_READ_CMD     0x03
#define EEPROM_EN_CMD       0x06
#define EEPROM_DI_CMD       0x04
#define EEPROM_PAGE_SIZE    16          // 24LC160A Page Size

unsigned char EE_Read_Buffer[20] = {0x00};
unsigned char EE_CMD_Buffer[20]= {0x00};
unsigned char Read_Dummy = 0x00;
unsigned char Dummy_Data = 0x00; 

 void main(void)
{
 
    SYSTEM_Initialize();

    LCD_L_Delay();              // 10mS
    OpenLCD();
    LCD_Set_Cursor(0,0);
    putrsLCD((const far char*)"Lab5 EEPROM Byte");

    EEPROM_CHIP_SELECT_SetHigh();
    __delay_ms(5);                           // wait for EEPROM Write

    EEPROM_CHIP_SELECT_SetLow();
    SPI1_Exchange8bit(EEPROM_EN_CMD);        //
    EEPROM_CHIP_SELECT_SetHigh();
    __delay_ms(1);                           // wait for EEPROM Write

    EEPROM_CHIP_SELECT_SetLow();
    SPI1_Exchange8bit(EEPROM_WRITE_CMD);
    SPI1_Exchange8bit(0x00);
    SPI1_Exchange8bit(0x00);
    SPI1_Exchange8bit(0xAA);
    SPI1_Exchange8bit(0x55);
    EEPROM_CHIP_SELECT_SetHigh();
    
    __delay_ms(10);                          // wait for EEPROM Write


    // Read Data from EEPROM and write to readBuffer
    EEPROM_CHIP_SELECT_SetLow();
    SPI1_Exchange8bit(EEPROM_READ_CMD);
    SPI1_Exchange8bit(0x00);
    SPI1_Exchange8bit(0x00);
    EE_Read_Buffer[0] = SPI1_Exchange8bit(DUMMY_DATA);
    EE_Read_Buffer[1] = SPI1_Exchange8bit(DUMMY_DATA);
    EEPROM_CHIP_SELECT_SetHigh();

    LCD_Set_Cursor(1,0);
    puthexLCD(EE_Read_Buffer[0]);
    putcLCD(' ');
    puthexLCD(EE_Read_Buffer[1]);
    putcLCD(' ');


    EE_CMD_Buffer[0] = EEPROM_READ_CMD;
    EE_CMD_Buffer[1] = 0x00;
    EE_CMD_Buffer[2] = 0x80;

    EEPROM_CHIP_SELECT_SetLow();
    SPI1_Exchange8bitBuffer(EE_CMD_Buffer,3,NULL);          //Send the EEPROM_READ_CMD
    SPI1_Exchange8bitBuffer(NULL, 10, EE_Read_Buffer);      // Read the actual EEPROM data
    EEPROM_CHIP_SELECT_SetHigh();

    while (1); 
    
}




/**
 End of File
*/
