/**
  User Application Source File

  Company:
    Microchip Technology Inc.

  File Name:
    app.c

  Summary:
    This is the user application source file which has application specific functions.

  Description:
    This is the user application source file which has functions necessary to execute the user application.

*/

/*
Copyright (c) 2013 - 2014 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
*/

/*Include files*/
#include "mcc_generated_files/mcc.h"
#include "app.h"

/*User defined variables*/
unsigned int A1000_mV, A100_mV, A10_mV,mV,V_temp;
unsigned int adcVoltValue;

/***************************User Functions*************************************/

/*
Function:
void ConvertADCVoltage ( unsigned int adc_conv_data )

Description:
Converts digital voltage to analog voltage
*/
void ConvertADCVoltage ( unsigned int adc_conv_data )
{
     adcVoltValue = (ADC_RESOLUTION * adc_conv_data);  // ADC 輸入值 乘以 4882.8 mV (為一個 ADC 一個解析單位的電壓值)

   // 16 進制轉換成 10 進制
    A1000_mV = adcVoltValue / 10000;        // 取出 V
    V_temp = adcVoltValue % 10000;
    A100_mV = V_temp / 1000;               // 取出 0.1V 的電壓值
    V_temp = V_temp % 1000;
    A10_mV = V_temp / 100;                 // 取出 0.01V
    V_temp = V_temp % 100;
    mV = V_temp / 10;                      // 取出 0.001V
}
void putrs1USART(const char *data)
{
  do
  {  // Transmit a byte
    EUSART1_Write(*data);               // 呼叫 enusart1.c 的函數 (from MCC)
  } while( *data++ );
}
