/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB® Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB® Code Configurator - v2.0
        Device            :  PIC18LF45K22
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.31
        MPLAB             :  MPLAB X 2.10
*/

/*
Copyright (c) 2013 - 2014 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
*/

#include "mcc_generated_files/mcc.h"
#include <stdio.h>
#include "music.h"
#include "app.h"

unsigned int EEPROM_Address;
unsigned char Table_Index;
/*
                         Main application
 */
void TMR1_EEPROM_Delay(void)
{
    __delay_ms(10);    
}

void main(void)
{
    uint16_t adcResult;
    uint8_t note = 0;

    // Initialize the device
    SYSTEM_Initialize();

    // 寫入音樂陣列表格 rowRow[] 到 EEPROM
    // 表格資料有 74 個，需用 5 次 Page Write 方式才可以完全寫入
    EEPROM_Address = 0x0000;    // 設定 EEPROM 起始位址
    Table_Index = 0;            // 查詢音樂表格索引值
    do
    {
        WriteSongToEEPROM(&rowRow[Table_Index], 16, EEPROM_Address);
        TMR1_EEPROM_Delay();
        EEPROM_Address += 0x10;                 // 指向下一個 Page 開始位址
        Table_Index += 16;                      // 指向下一個索引值
    }
    while (EEPROM_Address < 0x0050);

    // Read Data from EEPROM and write to readBuffer
    EEPROM_Address = 0x0000;    // 設定 EEPROM 起始位址
    Table_Index = 0;            // 放置音樂陣列的索引值
    do
    {
        ReadSongFromEEPROM(&readBuffer[Table_Index], 16, EEPROM_Address);
        EEPROM_Address += 0x10;
        Table_Index += 16;
    }
    while (EEPROM_Address < 0x0050);


    TMR1_Initialize();

    while (1) 
    {
        // Add your application code

        if (TMR1_HasOverflowOccured())
        {
            TMR1IF  = 0;
            adcResult = ADC_GetConversion(POT_CHANNEL);
            TMR1_WriteTimer(adcResult << 6);

            MusicPlay(&readBuffer[ note++ ]);
            if( readBuffer[note] == 0 )
            {
                note = 0;
            }

        }
    }
}




/**
 End of File
*/
