/**
  User Application Header File

  Company:
    Microchip Technology Inc.

  File Name:
    app.h

  Summary:
    This is the user application header file which has application specific functions.

  Description:
    This is the user application header file which has functions necessary to execute the user application.

*/

/*
Copyright (c) 2013 - 2014 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
*/


/*Include files*/
#include "mcc_generated_files/mcc.h"
#include "music.h"

#define MAX_SONG_SIZE (127)                            // Define Maximum Read buffer Size


extern uint8_t rowRow[];
extern uint8_t rowRowSize;
extern uint8_t readBuffer[];

/*
Function:
void ConvertADCVoltage ( unsigned int adc_conv_data )

Description:
Converts digital voltage to analog voltage
*/
void ConvertAdcVoltage ( unsigned int adcConvData );

/*
Function:
void ReadSongFromEEPROM(uint8_t* songRead, uint8_t size, uint16_t eepromAddr)

Description:
 Read EEPROM data of "size" form address location "eepromAddr" and write to buffer "songRead"
*/

void ReadSongFromEEPROM(uint8_t* songRead, uint8_t size, uint16_t eepromAddr);


/*
Function:
void ConvertADCVoltage ( unsigned int adc_conv_data )

Description:
Write EEPROM data of "size" starting at address location "eepromAddr" and using data form buffer "song"
*/
uint16_t WriteSongToEEPROM( uint8_t* song, uint8_t size, uint16_t eepromAddr);
